#ifndef _IF_H
#define _IF_H
/*
struct SelectFirstType
{
    template <class A, class B>
    struct Select
    {
        typedef A RET;
    };
};

struct SelectSecondType
{
    template <class A, class B>
    struct Select
    {
        typedef B RET;
    };
};

template <int condition>
struct SelectSelector
{
   typedef SelectFirstType RET;
};

template <>
struct SelectSelector <false>
{
   typedef SelectSecondType RET;
};

template <bool condition, class ThenType, class ElseType>
class IF
{
    typedef SelectSelector<condition>::RET Selector;

public:
    typedef Selector::Select<ThenType, ElseType>::RET RET;
};
*/

template <bool condition, class ThenType, class ElseType>
struct IF
{
    typedef ThenType RET;
};

template <class ThenType, class ElseType>
struct IF <false, ThenType, ElseType>
{
    typedef ElseType RET;
};


#endif // _IF_H
